Subject: Re: [PATCH v16 mfd 8/8] mfd: ocelot: add support for the vsc7512 chip via spi

From: Colin Foster <[email-masked]>
Date: Mon, 15 Aug 2022 07:19:13 -0700

Add Lee - My apologies, it seems like you got a new email address and I
didn't copy it on this series.

On Sun, Aug 14, 2022 at 05:55:53PM -0700, Colin Foster wrote:
> The VSC7512 is a networking chip that contains several peripherals. Many of
> these peripherals are currently supported by the VSC7513 and VSC7514 chips,
> but those run on an internal CPU. The VSC7512 lacks this CPU, and must be
> controlled externally.
> 
> Utilize the existing drivers by referencing the chip as an MFD. Add support
> for the two MDIO buses, the internal phys, pinctrl, and serial GPIO.
> 
> Signed-off-by: Colin Foster <[email-masked]>
> Reviewed-by: Vladimir Oltean <[email-masked]>
> ---
> 
> v16
>     * Includes fixups:
>     *  ocelot-core.c add includes device.h, export.h, iopoll.h, ioport,h
>     *  ocelot-spi.c add includes device.h, err.h, errno.h, export.h, 
>        mod_devicetable.h, types.h
>     *  Move kconfig.h from ocelot-spi.c to ocelot.h
>     *  Remove unnecessary byteorder.h

Something is going on that I don't fully understand with <asm/byteorder.h>.
I don't quite see how ocelot-core is throwing all sorts of errors in x86
builds now:

https://patchwork.hopto.org/static/nipa/667471/12942993/build_allmodconfig_warn/stderr

Snippet from there:

/home/nipa/nipa/tests/patch/build_32bit/build_32bit.sh: line 21: ccache gcc: command not found
../drivers/mfd/ocelot-spi.c: note: in included file (through ../include/linux/bitops.h, ../include/linux/kernel.h, ../arch/x86/include/asm/percpu.h, ../arch/x86/include/asm/current.h, ../include/linux/sched.h, ...):
../arch/x86/include/asm/bitops.h:66:1: warning: unreplaced symbol 'return'
../drivers/mfd/ocelot-spi.c: note: in included file (through ../include/linux/bitops.h, ../include/linux/kernel.h, ../arch/x86/include/asm/percpu.h, ../arch/x86/include/asm/current.h, ../include/linux/sched.h, ...):
../include/asm-generic/bitops/generic-non-atomic.h:29:9: warning: unreplaced symbol 'mask'
../include/asm-generic/bitops/generic-non-atomic.h:30:9: warning: unreplaced symbol 'p'
../include/asm-generic/bitops/generic-non-atomic.h:32:10: warning: unreplaced symbol 'p'
../include/asm-generic/bitops/generic-non-atomic.h:32:16: warning: unreplaced symbol 'mask'
../include/asm-generic/bitops/generic-non-atomic.h:27:1: warning: unreplaced symbol 'return'
../drivers/mfd/ocelot-spi.c: note: in included file (through ../arch/x86/include/asm/bitops.h, ../include/linux/bitops.h, ../include/linux/kernel.h, ../arch/x86/include/asm/percpu.h, ../arch/x86/include/asm/current.h, ...):
../include/asm-generic/bitops/instrumented-non-atomic.h:26:1: warning: unreplaced symbol 'return'

<asm/byteorder.h> was included in both drivers/mfd/ocelot-spi.c and
drivers/mfd/ocelot.h previously, though Andy pointed out there didn't
seem to be any users... and I didn't either. I'm sure there's something
I must be missing.

>     * Utilize resource_size() function
>